diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/click/model/ipv4-l3-click-protocol.h ns-3.41/src/click/model/ipv4-l3-click-protocol.h
--- ns-3.40/src/click/model/ipv4-l3-click-protocol.h	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/click/model/ipv4-l3-click-protocol.h	2024-02-09 14:44:07.869789800 -0800
@@ -21,6 +21,7 @@
 #ifndef IPV4_L3_CLICK_PROTOCOL_H
 #define IPV4_L3_CLICK_PROTOCOL_H
 
+#include "ns3/deprecated.h"
 #include "ns3/ipv4-interface.h"
 #include "ns3/ipv4-routing-protocol.h"
 #include "ns3/ipv4.h"
@@ -266,9 +267,15 @@
 
     void SetIpForward(bool forward) override;
     bool GetIpForward() const override;
+
+    NS_DEPRECATED_3_41("Use SetStrongEndSystemModel instead")
     void SetWeakEsModel(bool model) override;
+    NS_DEPRECATED_3_41("Use GetStrongEndSystemModel instead")
     bool GetWeakEsModel() const override;
 
+    void SetStrongEndSystemModel(bool model) override;
+    bool GetStrongEndSystemModel() const override;
+
     /**
      * \brief List of IPv4 interfaces.
      */
@@ -296,7 +303,7 @@
 
     Ptr<Ipv4RoutingProtocol> m_routingProtocol; //!< IPv4 routing protocol
     bool m_ipForward;                           //!< Whether IP forwarding is enabled
-    bool m_weakEsModel;                         //!< Whether to use weak Es model
+    bool m_strongEndSystemModel;                //!< Whether to use Strong End System Model
     L4List_t m_protocols;                       //!< List of IPv4 L4 protocols
     Ipv4InterfaceList m_interfaces;             //!< List of interfaces
     Ipv4InterfaceReverseContainer
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/click/test/examples-to-run.py ns-3.41/src/click/test/examples-to-run.py
--- ns-3.40/src/click/test/examples-to-run.py	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/click/test/examples-to-run.py	2024-02-09 14:44:07.869789800 -0800
@@ -9,8 +9,16 @@
 cpp_examples = [
     ("nsclick-simple-lan --clickConfigFolder=../../src/click/examples", "NSCLICK == True", "False"),
     ("nsclick-raw-wlan --clickConfigFolder=../../src/click/examples", "NSCLICK == True", "False"),
-    ("nsclick-udp-client-server-csma --clickConfigFolder=../../src/click/examples", "NSCLICK == True", "False"),
-    ("nsclick-udp-client-server-wifi --clickConfigFolder=../../src/click/examples", "NSCLICK == True", "False"),
+    (
+        "nsclick-udp-client-server-csma --clickConfigFolder=../../src/click/examples",
+        "NSCLICK == True",
+        "False",
+    ),
+    (
+        "nsclick-udp-client-server-wifi --clickConfigFolder=../../src/click/examples",
+        "NSCLICK == True",
+        "False",
+    ),
     ("nsclick-routing --clickConfigFolder=../../src/click/examples", "NSCLICK == True", "False"),
     ("nsclick-defines --clickConfigFolder=../../src/click/examples", "NSCLICK == True", "False"),
 ]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/CMakeLists.txt ns-3.41/src/CMakeLists.txt
--- ns-3.40/src/CMakeLists.txt	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/CMakeLists.txt	2024-02-09 14:44:07.845789700 -0800
@@ -15,9 +15,8 @@
     message(STATUS "Processing src/${libname}")
     add_subdirectory(${libname})
   else()
-    message(
-      ${HIGHLIGHTED_STATUS}
-      "Skipping src/${libname} : it does not contain a CMakeLists.txt file"
+    message(${HIGHLIGHTED_STATUS}
+            "Skipping src/${libname}: it does not contain a CMakeLists.txt file"
     )
   endif()
 endforeach()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/config-store/CMakeLists.txt ns-3.41/src/config-store/CMakeLists.txt
--- ns-3.40/src/config-store/CMakeLists.txt	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/config-store/CMakeLists.txt	2024-02-09 14:44:07.869789800 -0800
@@ -1,3 +1,6 @@
+set(gtk3_sources)
+set(gtk3_headers)
+set(gtk_libraries)
 if(${GTK3_FOUND})
   set(gtk3_sources
       model/display-functions.cc
@@ -19,11 +22,10 @@
         -Wl,--allow-shlib-undefined
     )
   endif()
-  if(${GCC})
-    add_definitions(-Wno-parentheses)
-  endif()
 endif()
 
+set(xml2_sources)
+set(xml2_libraries)
 if(${LIBXML2_FOUND})
   set(xml2_sources
       model/xml-config.cc
@@ -49,7 +51,6 @@
     model/config-store.h
   LIBRARIES_TO_LINK
     ${libcore}
-    ${libnetwork}
     ${xml2_libraries}
     ${gtk_libraries}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/config-store/model/config-store.cc ns-3.41/src/config-store/model/config-store.cc
--- ns-3.40/src/config-store/model/config-store.cc	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/config-store/model/config-store.cc	2024-02-09 14:44:07.869789800 -0800
@@ -56,7 +56,7 @@
             .AddAttribute("Mode",
                           "Configuration mode",
                           EnumValue(ConfigStore::NONE),
-                          MakeEnumAccessor(&ConfigStore::SetMode),
+                          MakeEnumAccessor<Mode>(&ConfigStore::SetMode),
                           MakeEnumChecker(ConfigStore::NONE,
                                           "None",
                                           ConfigStore::LOAD,
@@ -72,7 +72,7 @@
                 "FileFormat",
                 "Type of file format",
                 EnumValue(ConfigStore::RAW_TEXT),
-                MakeEnumAccessor(&ConfigStore::SetFileFormat),
+                MakeEnumAccessor<FileFormat>(&ConfigStore::SetFileFormat),
                 MakeEnumChecker(ConfigStore::RAW_TEXT, "RawText", ConfigStore::XML, "Xml"))
             .AddAttribute("SaveDeprecated",
                           "Save DEPRECATED attributes",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/CMakeLists.txt ns-3.41/src/core/CMakeLists.txt
--- ns-3.40/src/core/CMakeLists.txt	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/core/CMakeLists.txt	2024-02-09 14:44:07.869789800 -0800
@@ -14,38 +14,12 @@
 endif()
 
 # Check for dependencies and add sources accordingly
-if(${CMAKE_VERSION}
-   VERSION_LESS
-   "3.11.0"
+check_include_files(
+  "boost/units/quantity.hpp;boost/units/systems/si.hpp"
+  HAVE_BOOST_UNITS
+  LANGUAGE
+  CXX
 )
-  check_include_file_cxx(
-    boost/units/quantity.hpp
-    HAVE_BOOST_UNITS_QUANTITY
-  )
-  check_include_file_cxx(
-    boost/units/systems/si.hpp
-    HAVE_BOOST_UNITS_SI
-  )
-  if(${HAVE_BOOST_UNITS_QUANTITY}
-     AND ${HAVE_BOOST_UNITS_SI}
-  )
-    set(HAVE_BOOST_UNITS
-        TRUE
-    )
-  else()
-    set(HAVE_BOOST_UNITS
-        FALSE
-    )
-  endif()
-else()
-  # Fast path for CMake >= 3.11
-  check_include_files(
-    "boost/units/quantity.hpp;boost/units/systems/si.hpp"
-    HAVE_BOOST_UNITS
-    LANGUAGE
-    CXX
-  )
-endif()
 
 if(${HAVE_BOOST_UNITS})
   add_definitions(
@@ -97,6 +71,9 @@
   )
 endif()
 
+set(example_as_test_sources)
+set(example_as_test_headers)
+set(example_as_test_suite)
 if(${ENABLE_EXAMPLES})
   set(example_as_test_sources
       model/example-as-test.cc
@@ -177,7 +154,6 @@
     model/boolean.cc
     model/integer.cc
     model/uinteger.cc
-    model/enum.cc
     model/double.cc
     model/int64x64.cc
     model/string.cc
@@ -305,7 +281,7 @@
     model/type-name.h
     model/type-traits.h
     model/uinteger.h
-    model/unused.h
+    model/uniform-random-bit-generator.h
     model/valgrind.h
     model/vector.h
     model/warnings.h
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/examples/main-random-variable-stream.cc ns-3.41/src/core/examples/main-random-variable-stream.cc
--- ns-3.40/src/core/examples/main-random-variable-stream.cc	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/core/examples/main-random-variable-stream.cc	2024-02-09 14:44:07.869789800 -0800
@@ -556,6 +556,37 @@
     }
 
     {
+        std::cout << "BinomialRandomVariable......." << std::flush;
+        Gnuplot plot;
+        plot.SetTitle("BinomialRandomVariable");
+        plot.AppendExtra("set yrange [0:10]");
+
+        auto x = CreateObject<BinomialRandomVariable>();
+        x->SetAttribute("Trials", IntegerValue(10));
+        x->SetAttribute("Probability", DoubleValue(0.5));
+
+        plot.AddDataset(Histogram(x, probes, precision, "BinomialRandomVariable n=10 p=0.5"));
+
+        gnuplots.AddPlot(plot);
+        std::cout << "done" << std::endl;
+    }
+
+    {
+        std::cout << "BernoulliRandomVariable......." << std::flush;
+        Gnuplot plot;
+        plot.SetTitle("BernoulliRandomVariable");
+        plot.AppendExtra("set yrange [0:1]");
+
+        auto x = CreateObject<BernoulliRandomVariable>();
+        x->SetAttribute("Probability", DoubleValue(0.5));
+
+        plot.AddDataset(Histogram(x, probes, precision, "BernoulliRandomVariable p=0.5"));
+
+        gnuplots.AddPlot(plot);
+        std::cout << "done" << std::endl;
+    }
+
+    {
         std::string gnuFile = plotFile + ".plt";
         std::cout << "Writing Gnuplot file: " << gnuFile << "..." << std::flush;
         std::ofstream gnuStream(gnuFile);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/examples/sample-rng-plot.py ns-3.41/src/core/examples/sample-rng-plot.py
--- ns-3.40/src/core/examples/sample-rng-plot.py	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/core/examples/sample-rng-plot.py	2024-02-09 14:44:07.869789800 -0800
@@ -1,18 +1,17 @@
-# -*- Mode:Python; -*-
-# /*
-#  * This program is free software; you can redistribute it and/or modify
-#  * it under the terms of the GNU General Public License version 2 as
-#  * published by the Free Software Foundation
-#  *
-#  * This program is distributed in the hope that it will be useful,
-#  * but WITHOUT ANY WARRANTY; without even the implied warranty of
-#  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#  * GNU General Public License for more details.
-#  *
-#  * You should have received a copy of the GNU General Public License
-#  * along with this program; if not, write to the Free Software
-#  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#  */
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
 
 ## @file
 #  @ingroup core-examples
@@ -23,18 +22,26 @@
 #  This is adapted from Gustavo Carneiro's ns-3 tutorial
 
 
-import numpy as np
-import matplotlib.pyplot as plt
-import sys
 import argparse
-from ns import ns
+import sys
+
+import matplotlib.pyplot as plt
+import numpy as np
+
+## Import ns-3
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
 
 def main():
     parser = argparse.ArgumentParser("sample-rng-plot")
-    parser.add_argument("--not-blocking",
-                        action="store_true",
-                        default=False)
+    parser.add_argument("--not-blocking", action="store_true", default=False)
     args = parser.parse_args(sys.argv[1:])
 
     # mu, var = 100, 225
@@ -52,16 +59,16 @@
     ## Make a probability density histogram
     density = 1
     ## Plot color
-    facecolor = 'g'
+    facecolor = "g"
     ## Plot alpha value (transparency)
     alpha = 0.75
 
     # We don't really need the plot results, we're just going to show it later.
     # n, bins, patches = plt.hist(x, 50, density=1, facecolor='g', alpha=0.75)
-    n, bins, patches = plt.hist(x, 50, density=True, facecolor='g', alpha=0.75)
+    n, bins, patches = plt.hist(x, 50, density=True, facecolor="g", alpha=0.75)
 
-    plt.title('ns-3 histogram')
-    plt.text(60, .025, r'$\mu=100,\ \sigma=15$')
+    plt.title("ns-3 histogram")
+    plt.text(60, 0.025, r"$\mu=100,\ \sigma=15$")
     plt.axis([40, 160, 0, 0.03])
     plt.grid(True)
     plt.show(block=not args.not_blocking)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/examples/sample-simulator.py ns-3.41/src/core/examples/sample-simulator.py
--- ns-3.40/src/core/examples/sample-simulator.py	2023-09-27 13:30:37.622839000 -0700
+++ ns-3.41/src/core/examples/sample-simulator.py	2024-02-09 14:44:07.869789800 -0800
@@ -1,22 +1,21 @@
-# -*- Mode:Python; -*-
-# /*
-#  * Copyright (c) 2010 INRIA
-#  *
-#  * This program is free software; you can redistribute it and/or modify
-#  * it under the terms of the GNU General Public License version 2 as
-#  * published by the Free Software Foundation;
-#  *
-#  * This program is distributed in the hope that it will be useful,
-#  * but WITHOUT ANY WARRANTY; without even the implied warranty of
-#  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#  * GNU General Public License for more details.
-#  *
-#  * You should have received a copy of the GNU General Public License
-#  * along with this program; if not, write to the Free Software
-#  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#  *
-#  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
-#  */
+#
+# Copyright (c) 2010 INRIA
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation;
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+# Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+#
 #
 # Python version of sample-simulator.cc
 
@@ -25,20 +24,31 @@
 #  \ingroup simulator
 #  Python example program demonstrating use of various Schedule functions.
 
+## Import ns-3
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
 
-from ns import ns
 
 ## Example function - triggered at a random time.
 ## \return None.
 def RandomFunction():
-    print ("RandomFunction received event at", ns.core.Simulator.Now().GetSeconds(), "s")
+    print("RandomFunction received event at", ns.core.Simulator.Now().GetSeconds(), "s")
+
 
 ## Example function - triggered if an event is canceled (should not be called).
 ## \return None.
 def CancelledEvent():
-    print ("I should never be called... ")
+    print("I should never be called... ")
+
 
-ns.cppyy.cppdef("""
+ns.cppyy.cppdef(
+    """
     #include "CPyCppyy/API.h"
 
     using namespace ns3;
@@ -100,7 +110,8 @@
     {
         return MakeEvent(&CancelledFunctionCpp);
     }
-   """)
+   """
+)
 
 
 def main(argv):
@@ -126,6 +137,8 @@
 
     ns.core.Simulator.Destroy()
 
-if __name__ == '__main__':
+
+if __name__ == "__main__":
     import sys
+
     main(sys.argv)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/default-simulator-impl.cc ns-3.41/src/core/model/default-simulator-impl.cc
--- ns-3.40/src/core/model/default-simulator-impl.cc	2023-09-27 13:30:37.626839000 -0700
+++ ns-3.41/src/core/model/default-simulator-impl.cc	2024-02-09 14:44:07.873789800 -0800
@@ -209,11 +209,11 @@
     m_stop = true;
 }
 
-void
+EventId
 DefaultSimulatorImpl::Stop(const Time& delay)
 {
     NS_LOG_FUNCTION(this << delay.GetTimeStep());
-    Simulator::Schedule(delay, &Simulator::Stop);
+    return Simulator::Schedule(delay, &Simulator::Stop);
 }
 
 //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/default-simulator-impl.h ns-3.41/src/core/model/default-simulator-impl.h
--- ns-3.40/src/core/model/default-simulator-impl.h	2023-09-27 13:30:37.626839000 -0700
+++ ns-3.41/src/core/model/default-simulator-impl.h	2024-02-09 14:44:07.873789800 -0800
@@ -61,7 +61,7 @@
     void Destroy() override;
     bool IsFinished() const override;
     void Stop() override;
-    void Stop(const Time& delay) override;
+    EventId Stop(const Time& delay) override;
     EventId Schedule(const Time& delay, EventImpl* event) override;
     void ScheduleWithContext(uint32_t context, const Time& delay, EventImpl* event) override;
     EventId ScheduleNow(EventImpl* event) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/deprecated.h ns-3.41/src/core/model/deprecated.h
--- ns-3.40/src/core/model/deprecated.h	2023-09-27 13:30:37.626839000 -0700
+++ ns-3.41/src/core/model/deprecated.h	2024-02-09 14:44:07.873789800 -0800
@@ -76,37 +76,16 @@
 
 /**
  * \ingroup core
- * \def NS_DEPRECATED_3_40
- * Tag for things deprecated in version ns-3.40.
- */
-#define NS_DEPRECATED_3_40(msg) NS_DEPRECATED(msg)
-
-/**
- * \ingroup core
- * \def NS_DEPRECATED_3_39
- * Tag for things deprecated in version ns-3.39.
- */
-#define NS_DEPRECATED_3_39(msg) NS_DEPRECATED(msg)
-
-/**
- * \ingroup core
- * \def NS_DEPRECATED_3_38
- * Tag for things deprecated in version ns-3.38.
+ * \def NS_DEPRECATED_3_41
+ * Tag for things deprecated in version ns-3.41.
  */
-#define NS_DEPRECATED_3_38(msg) NS_DEPRECATED(msg)
+#define NS_DEPRECATED_3_41(msg) NS_DEPRECATED(msg)
 
 /**
  * \ingroup core
- * \def NS_DEPRECATED_3_37
- * Tag for things deprecated in version ns-3.37.
- */
-#define NS_DEPRECATED_3_37(msg) NS_DEPRECATED(msg)
-
-/**
- * \ingroup core
- * \def NS_DEPRECATED_3_36
- * Tag for things deprecated in version ns-3.36.
+ * \def NS_DEPRECATED_3_40
+ * Tag for things deprecated in version ns-3.40.
  */
-#define NS_DEPRECATED_3_36(msg) NS_DEPRECATED(msg)
+#define NS_DEPRECATED_3_40(msg) NS_DEPRECATED(msg)
 
 #endif /* NS3_DEPRECATED_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/enum.h ns-3.41/src/core/model/enum.h
--- ns-3.40/src/core/model/enum.h	2023-09-27 13:30:37.626839000 -0700
+++ ns-3.41/src/core/model/enum.h	2024-02-09 14:44:07.877790000 -0800
@@ -22,7 +22,12 @@
 #include "attribute-accessor-helper.h"
 #include "attribute.h"
 
+#include <algorithm> // find_if
 #include <list>
+#include <numeric> // std::accumulate
+#include <sstream>
+#include <type_traits>
+#include <typeinfo>
 
 /**
  * \file
@@ -52,6 +57,7 @@
  *                       EnumValue (RipNg::NO_SPLIT_HORIZON));
  * \endcode
  */
+template <typename T>
 class EnumValue : public AttributeValue
 {
   public:
@@ -61,10 +67,10 @@
      *
      * \param [in] value The value to begin with.
      */
-    EnumValue(int value);
-    void Set(int value);
-    int Get() const;
-    template <typename T>
+    EnumValue(T value);
+    void Set(T value);
+    T Get() const;
+
     bool GetAccessor(T& value) const;
 
     Ptr<AttributeValue> Copy() const override;
@@ -72,17 +78,48 @@
     bool DeserializeFromString(std::string value, Ptr<const AttributeChecker> checker) override;
 
   private:
-    int m_value; //!< The stored integer value.
+    T m_value; //!< The stored value.
 };
 
 template <typename T>
+EnumValue<T>::EnumValue() = default;
+
+template <typename T>
+EnumValue<T>::EnumValue(T value)
+    : m_value(value)
+{
+}
+
+template <typename T>
+void
+EnumValue<T>::Set(T value)
+{
+    m_value = value;
+}
+
+template <typename T>
+T
+EnumValue<T>::Get() const
+{
+    return m_value;
+}
+
+template <typename T>
 bool
-EnumValue::GetAccessor(T& value) const
+EnumValue<T>::GetAccessor(T& value) const
 {
-    value = T(m_value);
+    value = static_cast<T>(m_value);
     return true;
 }
 
+template <typename T>
+Ptr<AttributeValue>
+EnumValue<T>::Copy() const
+{
+    return Create<EnumValue>(*this);
+}
+
+template <typename T>
 class EnumChecker : public AttributeChecker
 {
   public:
@@ -93,27 +130,27 @@
      * \param [in] value The value.
      * \param [in] name Then enum symbol name.
      */
-    void AddDefault(int value, std::string name);
+    void AddDefault(T value, std::string name);
     /**
      * Add a new value.
      * \param [in] value The value.
      * \param [in] name The enum symbol name.
      */
-    void Add(int value, std::string name);
+    void Add(T value, std::string name);
 
     /**
      * Get the enum symbol name by value.
      * \param [in] value The value.
      * \return The enum symbol name.
      */
-    std::string GetName(int value) const;
+    std::string GetName(T value) const;
 
     /**
      * Get the enum value by name.
      * \param [in] name Then enum symbol name.
      * \returns The enum value.
      */
-    int GetValue(const std::string name) const;
+    T GetValue(const std::string name) const;
 
     // Inherited
     bool Check(const AttributeValue& value) const override;
@@ -125,19 +162,13 @@
 
   private:
     /** Type for the pair value, name */
-    typedef std::pair<int, std::string> Value;
+    using Value = std::pair<T, std::string>;
     /** Type of container for storing Enum values and symbol names. */
-    typedef std::list<Value> ValueSet;
+    using ValueSet = std::list<Value>;
     /** The stored Enum values and symbol names. */
     ValueSet m_valueSet;
 };
 
-template <typename T1>
-Ptr<const AttributeAccessor> MakeEnumAccessor(T1 a1);
-
-template <typename T1, typename T2>
-Ptr<const AttributeAccessor> MakeEnumAccessor(T1 a1, T2 a2);
-
 /**
  * Make an EnumChecker pre-configured with a set of allowed
  * values by name.
@@ -152,17 +183,17 @@
  * \see AttributeChecker
  *
  * \tparam Ts The type list of additional parameters. Additional parameters
- *            should be int, string pairs.
+ *            should be T, string pairs.
  * \returns The AttributeChecker
  * \param [in] v  The default enum value.
  * \param [in] n  The corresponding name.
  * \param [in] args Any additional arguments.
  */
-template <typename... Ts>
+template <typename T, typename... Ts>
 Ptr<const AttributeChecker>
-MakeEnumChecker(int v, std::string n, Ts... args)
+MakeEnumChecker(T v, std::string n, Ts... args)
 {
-    Ptr<EnumChecker> checker = Create<EnumChecker>();
+    Ptr<EnumChecker<T>> checker = Create<EnumChecker<T>>();
     checker->AddDefault(v, n);
     return MakeEnumChecker(checker, args...);
 }
@@ -171,17 +202,16 @@
  * Handler for enum value, name pairs other than the default.
  *
  * \tparam Ts The type list of additional parameters. Additional parameters
- *            should be in int, string pairs.
+ *            should be T, string pairs.
  * \returns The AttributeChecker
  * \param [in] checker The AttributeChecker.
  * \param [in] v  The next enum value.
  * \param [in] n  The corresponding name.
  * \param [in] args Any additional arguments.
  */
-
-template <typename... Ts>
+template <typename T, typename... Ts>
 Ptr<const AttributeChecker>
-MakeEnumChecker(Ptr<EnumChecker> checker, int v, std::string n, Ts... args)
+MakeEnumChecker(Ptr<EnumChecker<T>> checker, T v, std::string n, Ts... args)
 {
     checker->Add(v, n);
     return MakeEnumChecker(checker, args...);
@@ -194,24 +224,171 @@
  * \param [in] checker The AttributeChecker.
  */
 // inline to allow tail call optimization
+template <typename T>
 inline Ptr<const AttributeChecker>
-MakeEnumChecker(Ptr<EnumChecker> checker)
+MakeEnumChecker(Ptr<EnumChecker<T>> checker)
 {
     return checker;
 }
 
-template <typename T1>
+template <typename T, typename T1>
 Ptr<const AttributeAccessor>
 MakeEnumAccessor(T1 a1)
 {
-    return MakeAccessorHelper<EnumValue>(a1);
+    return MakeAccessorHelper<EnumValue<T>>(a1);
 }
 
-template <typename T1, typename T2>
+template <typename T, typename T1, typename T2>
 Ptr<const AttributeAccessor>
 MakeEnumAccessor(T1 a1, T2 a2)
 {
-    return MakeAccessorHelper<EnumValue>(a1, a2);
+    return MakeAccessorHelper<EnumValue<T>>(a1, a2);
+}
+
+template <typename T>
+std::string
+EnumValue<T>::SerializeToString(Ptr<const AttributeChecker> checker) const
+{
+    const auto p = dynamic_cast<const EnumChecker<T>*>(PeekPointer(checker));
+    NS_ASSERT(p != nullptr);
+    std::string name = p->GetName(m_value);
+    return name;
+}
+
+template <typename T>
+bool
+EnumValue<T>::DeserializeFromString(std::string value, Ptr<const AttributeChecker> checker)
+{
+    const auto p = dynamic_cast<const EnumChecker<T>*>(PeekPointer(checker));
+    NS_ASSERT(p != nullptr);
+    m_value = p->GetValue(value);
+    return true;
+}
+
+template <typename T>
+EnumChecker<T>::EnumChecker()
+{
+}
+
+template <typename T>
+void
+EnumChecker<T>::AddDefault(T value, std::string name)
+{
+    m_valueSet.emplace_front(value, name);
+}
+
+template <typename T>
+void
+EnumChecker<T>::Add(T value, std::string name)
+{
+    m_valueSet.emplace_back(value, name);
+}
+
+template <typename T>
+std::string
+EnumChecker<T>::GetName(T value) const
+{
+    auto it = std::find_if(m_valueSet.begin(), m_valueSet.end(), [value](Value v) {
+        return v.first == value;
+    });
+
+    NS_ASSERT_MSG(it != m_valueSet.end(),
+                  "invalid enum value " << static_cast<int>(value)
+                                        << "! Missed entry in MakeEnumChecker?");
+    return it->second;
+}
+
+template <typename T>
+T
+EnumChecker<T>::GetValue(const std::string name) const
+{
+    auto it = std::find_if(m_valueSet.begin(), m_valueSet.end(), [name](Value v) {
+        return v.second == name;
+    });
+    NS_ASSERT_MSG(
+        it != m_valueSet.end(),
+        "name "
+            << name
+            << " is not a valid enum value. Missed entry in MakeEnumChecker?\nAvailable values: "
+            << std::accumulate(m_valueSet.begin(),
+                               m_valueSet.end(),
+                               std::string{},
+                               [](std::string a, Value v) {
+                                   if (a.empty())
+                                   {
+                                       return v.second;
+                                   }
+                                   else
+                                   {
+                                       return std::move(a) + ", " + v.second;
+                                   }
+                               }));
+    return it->first;
+}
+
+template <typename T>
+bool
+EnumChecker<T>::Check(const AttributeValue& value) const
+{
+    const auto p = dynamic_cast<const EnumValue<T>*>(&value);
+    if (!p)
+    {
+        return false;
+    }
+    auto pvalue = p->Get();
+    auto it = std::find_if(m_valueSet.begin(), m_valueSet.end(), [pvalue](Value v) {
+        return v.first == pvalue;
+    });
+    return (it != m_valueSet.end());
+}
+
+template <typename T>
+std::string
+EnumChecker<T>::GetValueTypeName() const
+{
+    return "ns3::EnumValue<" + std::string(typeid(T).name()) + ">";
+}
+
+template <typename T>
+bool
+EnumChecker<T>::HasUnderlyingTypeInformation() const
+{
+    return true;
+}
+
+template <typename T>
+std::string
+EnumChecker<T>::GetUnderlyingTypeInformation() const
+{
+    std::ostringstream oss;
+    bool moreValues = false;
+    for (const auto& i : m_valueSet)
+    {
+        oss << (moreValues ? "|" : "") << i.second;
+        moreValues = true;
+    }
+    return oss.str();
+}
+
+template <typename T>
+Ptr<AttributeValue>
+EnumChecker<T>::Create() const
+{
+    return ns3::Create<EnumValue<T>>();
+}
+
+template <typename T>
+bool
+EnumChecker<T>::Copy(const AttributeValue& source, AttributeValue& destination) const
+{
+    const auto src = dynamic_cast<const EnumValue<T>*>(&source);
+    auto dst = dynamic_cast<EnumValue<T>*>(&destination);
+    if (!src || !dst)
+    {
+        return false;
+    }
+    *dst = *src;
+    return true;
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/int64x64-128.cc ns-3.41/src/core/model/int64x64-128.cc
--- ns-3.40/src/core/model/int64x64-128.cc	2023-09-27 13:30:37.626839000 -0700
+++ ns-3.41/src/core/model/int64x64-128.cc	2024-02-09 14:44:07.877790000 -0800
@@ -225,7 +225,7 @@
     a <<= 64;
     int64x64_t result;
     result._v = Udiv(a, v);
-    int64x64_t tmp = int64x64_t(v, false);
+    int64x64_t tmp(v, 0);
     tmp.MulByInvert(result);
     if (tmp.GetHigh() != 1)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/log.cc ns-3.41/src/core/model/log.cc
--- ns-3.40/src/core/model/log.cc	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/log.cc	2024-02-09 14:44:07.881790000 -0800
@@ -535,36 +535,4 @@
     }
 }
 
-template <>
-ParameterLogger&
-ParameterLogger::operator<< <std::string>(const std::string& param)
-{
-    CommaRest();
-    m_os << "\"" << param << "\"";
-    return *this;
-}
-
-ParameterLogger&
-ParameterLogger::operator<<(const char* param)
-{
-    (*this) << std::string(param);
-    return *this;
-}
-
-template <>
-ParameterLogger&
-ParameterLogger::operator<< <int8_t>(const int8_t param)
-{
-    (*this) << static_cast<int16_t>(param);
-    return *this;
-}
-
-template <>
-ParameterLogger&
-ParameterLogger::operator<< <uint8_t>(const uint8_t param)
-{
-    (*this) << static_cast<uint16_t>(param);
-    return *this;
-}
-
 } // namespace ns3
